Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4130)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4131)
@@ -10975,60 +11243,15 @@
              resorted = .TRUE.
           ELSE
-             to_be_resorted => nbins_av(:,:,:,ib)
+             temp_array = nbins_av(:,:,:,ib)
+             to_be_resorted => temp_array
           ENDIF
-
-       CASE ( 'Ntot' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nz_do3d
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
-                      ENDDO
-                      tend(k,j,i) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO 
-             IF ( .NOT. mask_surface(mid) )  THEN   
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ELSE 
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
-                                                                  grid )
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
-                                                 mask_j(mid,j), mask_i(mid,i) )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-             resorted = .TRUE.
-          ELSE
-             to_be_resorted => ntot_av
-          ENDIF
-
-       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',      &
-              'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
-          IF ( TRIM( variable(6:) ) == '1' ) ib = 1
-          IF ( TRIM( variable(6:) ) == '2' ) ib = 2
-          IF ( TRIM( variable(6:) ) == '3' ) ib = 3
-          IF ( TRIM( variable(6:) ) == '4' ) ib = 4
-          IF ( TRIM( variable(6:) ) == '5' ) ib = 5
-          IF ( TRIM( variable(6:) ) == '6' ) ib = 6
-          IF ( TRIM( variable(6:) ) == '7' ) ib = 7
-          IF ( TRIM( variable(6:) ) == '8' ) ib = 8
-          IF ( TRIM( variable(6:) ) == '9' ) ib = 9
-          IF ( TRIM( variable(6:) ) == '10' ) ib = 10
-          IF ( TRIM( variable(6:) ) == '11' ) ib = 11
-          IF ( TRIM( variable(6:) ) == '12' ) ib = 12
-
+       ENDIF
+
+    ELSEIF ( variable(7:11) == 'm_bin' )  THEN
+
+       READ( variable(12:),* ) char_to_int
+       IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
+
+          ib = char_to_int
           IF ( av == 0 )  THEN
              DO  i = nxl, nxr
@@ -11065,95 +11288,335 @@
              resorted = .TRUE.
           ELSE
-             to_be_resorted => mbins_av(:,:,:,ib)
+             temp_array = mbins_av(:,:,:,ib)
+             to_be_resorted => temp_array
           ENDIF
-
-       CASE ( 'PM2.5' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nz_do3d
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
-                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
-                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
-                            ENDDO
-                         ENDIF
-                      ENDDO
-                      tend(k,j,i) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO 
-             IF ( .NOT. mask_surface(mid) )  THEN
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
+       ENDIF
+
+    ELSE
+       SELECT CASE ( TRIM( variable(7:) ) )
+
+          CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV' )
+             vari = TRIM( variable(7:) )
+             IF ( av == 0 )  THEN
+                IF ( vari == 'g_H2SO4')  to_be_resorted => salsa_gas(1)%conc
+                IF ( vari == 'g_HNO3')   to_be_resorted => salsa_gas(2)%conc
+                IF ( vari == 'g_NH3')    to_be_resorted => salsa_gas(3)%conc
+                IF ( vari == 'g_OCNV')   to_be_resorted => salsa_gas(4)%conc
+                IF ( vari == 'g_OCSV')   to_be_resorted => salsa_gas(5)%conc
+             ELSE
+                IF ( vari == 'g_H2SO4') to_be_resorted => g_h2so4_av
+                IF ( vari == 'g_HNO3')  to_be_resorted => g_hno3_av
+                IF ( vari == 'g_NH3')   to_be_resorted => g_nh3_av
+                IF ( vari == 'g_OCNV')  to_be_resorted => g_ocnv_av
+                IF ( vari == 'g_OCSV')  to_be_resorted => g_ocsv_av
+             ENDIF
+
+          CASE ( 'LDSA' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nz_do3d
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+   !
+   !--                      Diameter in micrometres
+                            mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp
+   !
+   !--                      Deposition factor: alveolar
+                            df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +    &
+                                   2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -  &
+                                   1.362_wp )**2 ) )
+   !
+   !--                      Lung-deposited surface area LDSA (units mum2/cm3)
+                            temp_bin = temp_bin + pi * mean_d**2 * df * 1.0E-6_wp *                &
+                                       aerosol_number(ib)%conc(k,j,i)
+                         ENDDO
+                         tend(k,j,i) = temp_bin
                       ENDDO
                    ENDDO
                 ENDDO
-             ELSE 
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
-                                                                  grid )
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
-                                                 mask_j(mid,j), mask_i(mid,i) )
+                IF ( .NOT. mask_surface(mid) )  THEN
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
                       ENDDO
                    ENDDO
-                ENDDO
+                ELSE 
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i), &
+                                                                     grid )
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),      &
+                                                    mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+                resorted = .TRUE.
+             ELSE
+                to_be_resorted => ldsa_av
              ENDIF
-             resorted = .TRUE.
-          ELSE
-             to_be_resorted => pm25_av
-          ENDIF
-
-       CASE ( 'PM10' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nz_do3d
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
-                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+
+          CASE ( 'N_UFP' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nz_do3d
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 0.1E-6_wp )  THEN
+                               temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                            ENDIF
+                         ENDDO
+                         tend(k,j,i) = temp_bin
+                      ENDDO
+                   ENDDO
+                ENDDO 
+                IF ( .NOT. mask_surface(mid) )  THEN
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ELSE 
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i), &
+                                                                     grid )
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),      &
+                                                    mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+                resorted = .TRUE.
+             ELSE
+                to_be_resorted => nufp_av
+             ENDIF
+
+          CASE ( 'Ntot' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nz_do3d
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                         ENDDO
+                         tend(k,j,i) = temp_bin
+                      ENDDO
+                   ENDDO
+                ENDDO 
+                IF ( .NOT. mask_surface(mid) )  THEN
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ELSE 
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i), &
+                                                                     grid )
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),      &
+                                                    mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+                resorted = .TRUE.
+             ELSE
+                to_be_resorted => ntot_av
+             ENDIF
+
+          CASE ( 'PM0.1' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nz_do3d
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 0.1E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         tend(k,j,i) = temp_bin
+                      ENDDO
+                   ENDDO
+                ENDDO 
+                IF ( .NOT. mask_surface(mid) )  THEN
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ELSE 
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i), &
+                                                                     grid )
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),      &
+                                                    mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+                resorted = .TRUE.
+             ELSE
+                to_be_resorted => pm01_av
+             ENDIF
+
+          CASE ( 'PM2.5' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nz_do3d
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         tend(k,j,i) = temp_bin
+                      ENDDO
+                   ENDDO
+                ENDDO 
+                IF ( .NOT. mask_surface(mid) )  THEN
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ELSE 
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i), &
+                                                                     grid )
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),      &
+                                                    mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+                resorted = .TRUE.
+             ELSE
+                to_be_resorted => pm25_av
+             ENDIF
+
+          CASE ( 'PM10' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nz_do3d
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         tend(k,j,i) = temp_bin
+                      ENDDO
+                   ENDDO
+                ENDDO 
+                IF ( .NOT. mask_surface(mid) )  THEN
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ELSE 
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i), &
+                                                                     grid )
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),      &
+                                                    mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+                resorted = .TRUE.
+             ELSE
+                to_be_resorted => pm10_av
+             ENDIF
+
+          CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
+             IF ( av == 0 )  THEN
+                IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
+                   found_index = get_index( prtcl, TRIM( variable(3:) ) )
+                   DO  i = nxl, nxr
+                      DO  j = nys, nyn
+                         DO  k = nzb, nz_do3d
+                            temp_bin = 0.0_wp
+                            DO  ic = ( found_index-1 ) * nbins_aerosol + 1, found_index * nbins_aerosol
                                temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                             ENDDO
-                         ENDIF
-                      ENDDO
-                      tend(k,j,i) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO 
-             IF ( .NOT. mask_surface(mid) )  THEN
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
+                            tend(k,j,i) = temp_bin
+                         ENDDO
                       ENDDO
                    ENDDO
-                ENDDO
-             ELSE 
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
-                                                                  grid )
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
-                                                 mask_j(mid,j), mask_i(mid,i) )
+                ELSE
+                   tend = 0.0_wp
+                ENDIF
+                IF ( .NOT. mask_surface(mid) )  THEN
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( mask_k(mid,k), mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
                       ENDDO
                    ENDDO
-                ENDDO
+                ELSE
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i), &
+                                                                     grid )
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),      &
+                                                    mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+                resorted = .TRUE.
+             ELSE
+!
+!--             9: remove salsa_s_ from the beginning
+                IF ( TRIM( variable(9:) ) == 'BC' )   to_be_resorted => s_bc_av
+                IF ( TRIM( variable(9:) ) == 'DU' )   to_be_resorted => s_du_av
+                IF ( TRIM( variable(9:) ) == 'NH' )   to_be_resorted => s_nh_av
+                IF ( TRIM( variable(9:) ) == 'NO' )   to_be_resorted => s_no_av
+                IF ( TRIM( variable(9:) ) == 'OC' )   to_be_resorted => s_oc_av
+                IF ( TRIM( variable(9:) ) == 'SO4' )  to_be_resorted => s_so4_av
+                IF ( TRIM( variable(9:) ) == 'SS' )   to_be_resorted => s_ss_av
              ENDIF
-             resorted = .TRUE.
-          ELSE
-             to_be_resorted => pm10_av
-          ENDIF
-
-       CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
-          IF ( av == 0 )  THEN
-             IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
-                found_index = get_index( prtcl, TRIM( variable(3:) ) )
+
+          CASE ( 's_H2O' )
+             IF ( av == 0 )  THEN
+                found_index = get_index( prtcl, 'H2O' )
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
@@ -11167,81 +11630,34 @@
                    ENDDO
                 ENDDO
-             ELSE
-                tend = 0.0_wp
-             ENDIF
-             IF ( .NOT. mask_surface(mid) )  THEN
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k), mask_j(mid,j), mask_i(mid,i) )
+                IF ( .NOT. mask_surface(mid) )  THEN
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( mask_k(mid,k), mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
                       ENDDO
                    ENDDO
-                ENDDO
-             ELSE
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
-                                                                  grid )
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
-                                                 mask_j(mid,j), mask_i(mid,i) )
+                ELSE
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i), &
+                                                                     grid )
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),      &
+                                                    mask_j(mid,j), mask_i(mid,i) )
+                         ENDDO
                       ENDDO
                    ENDDO
-                ENDDO
+                ENDIF
+                resorted = .TRUE.
+             ELSE
+                to_be_resorted => s_h2o_av
              ENDIF
-             resorted = .TRUE.
-          ELSE
-             IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_bc_av
-             IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_du_av
-             IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_nh_av
-             IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_no_av
-             IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_oc_av
-             IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_so4_av
-             IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_ss_av
-          ENDIF
-
-       CASE ( 's_H2O' )
-          IF ( av == 0 )  THEN
-             found_index = get_index( prtcl, 'H2O' )
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nz_do3d
-                      temp_bin = 0.0_wp
-                      DO  ic = ( found_index-1 ) * nbins_aerosol + 1, found_index * nbins_aerosol
-                         temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
-                      ENDDO
-                      tend(k,j,i) = temp_bin
-                   ENDDO
-                ENDDO
-             ENDDO
-             IF ( .NOT. mask_surface(mid) )  THEN
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k), mask_j(mid,j), mask_i(mid,i) )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ELSE
-                DO  i = 1, mask_size_l(mid,1)
-                   DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
-                                                                  grid )
-                      DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
-                                                 mask_j(mid,j), mask_i(mid,i) )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-             resorted = .TRUE.
-          ELSE
-             to_be_resorted => s_h2o_av
-          ENDIF
-
-       CASE DEFAULT
-          found = .FALSE.
-
-    END SELECT
+
+          CASE DEFAULT
+             found = .FALSE.
+
+       END SELECT
+    ENDIF
 
     IF ( .NOT. resorted )  THEN
@@ -11252,5 +11668,5 @@
              DO  j = 1, mask_size_l(mid,2)
                 DO  k = 1, mask_size_l(mid,3)
-                   local_pf(i,j,k) = to_be_resorted( mask_k(mid,k), mask_j(mid,j),mask_i(mid,i) )
+                   local_pf(i,j,k) = to_be_resorted( mask_k(mid,k), mask_j(mid,j), mask_i(mid,i) )
                 ENDDO
              ENDDO
@@ -11293,5 +11709,5 @@
     INTEGER(iwp), INTENT(inout) ::  ncomp  !< Number of components
 
-    CHARACTER(len=3), INTENT(in) ::  listcomp(nlist)  !< List cof component names
+    CHARACTER(LEN=3), INTENT(in) ::  listcomp(nlist)  !< List cof component names
 
     TYPE(component_index), INTENT(inout) ::  self  !< Object containing the indices of different
@@ -11329,5 +11745,5 @@
     IMPLICIT NONE
 
-    CHARACTER(len=*), INTENT(in) ::  incomp !< Component name
+    CHARACTER(LEN=*), INTENT(in) ::  incomp !< Component name
 
     INTEGER(iwp) ::  ii  !< index
@@ -11359,5 +11775,5 @@
     IMPLICIT NONE
 
-    CHARACTER(len=*), INTENT(in) ::  icomp !< Component name
+    CHARACTER(LEN=*), INTENT(in) ::  icomp !< Component name
 
     TYPE(component_index), INTENT(in) ::  self  !< Object containing the indices of different
Index: palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d	(revision 4130)
+++ palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d	(revision 4131)
@@ -94,4 +94,6 @@
                             '#theta', 'theta*2', 'wtheta', 'w*theta*', 'w"theta"',
                             '#q',  'q*2', 
+                            'salsa_Ntot', 'salsa_N_UFP', 'salsa_LDSA', 
+                            'salsa_PM0.1', 'salsa_PM2.5', 'salsa_PM10', 
 !
 !-- 2D/3D output settings
